<script setup lang="ts">
import UploadOCELFile from "@/components/UploadOCELFile.vue";
import OCELFileList from "@/components/OCELFileList.vue";
import { reactive, ref } from "vue";
import type { API_File } from "@/types";

const state = reactive<{
  selected_file: API_File | null;
}>({
  selected_file: null,
});

/* reference for component */
const fileList = ref<typeof OCELFileList | null>(null);

const emit = defineEmits<{
  (e: "filechange", file: API_File | null): void;
}>();

async function onUploadFinished(id: string) {
  await fileList.value?.load_ocel_files(); // Update list and wait for update!
  fileList.value?.select_file(id); // Set to id, waiting before is important!
}

function onUploadFailed(error_msg: string): void {
  alert("File upload failed! Message: " + error_msg);
}

function onSelectionChange(file: API_File | null) {
  state.selected_file = file;
  emit("filechange", state.selected_file);
}
</script>

<template>
  <div class="row border-bottom mb-3 pb-3">
    <h4 class="text-light">Select / Upload your OCEL-file</h4>
    <div class="col-12 mb-1">
      <OCELFileList ref="fileList" @selectionchange="onSelectionChange" />
    </div>
    <div class="col-12 mb-2">
      <UploadOCELFile
        @uploadfinished="onUploadFinished"
        @uploadfailed="onUploadFailed"
      >
        Add file
      </UploadOCELFile>
    </div>
  </div>
</template>
